/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
import { ChangeDetectionStrategy, Component, EventEmitter, Input, Output, ViewChild } from "@angular/core";
import { FormGroup } from "@angular/forms";
import { NgbRating, NgbRatingConfig } from "@ng-bootstrap/ng-bootstrap";
import { DynamicFormLayoutService, DynamicFormValidationService, DynamicFormControlComponent, DynamicRatingModel } from "@ss-dynamic-forms/core";
export class DynamicNGBootstrapRatingComponent extends DynamicFormControlComponent {
    /**
     * @param {?} layoutService
     * @param {?} validationService
     * @param {?} config
     */
    constructor(layoutService, validationService, config) {
        super(layoutService, validationService);
        this.layoutService = layoutService;
        this.validationService = validationService;
        this.config = config;
        this.blur = new EventEmitter();
        this.change = new EventEmitter();
        this.focus = new EventEmitter();
    }
}
DynamicNGBootstrapRatingComponent.decorators = [
    { type: Component, args: [{
                selector: "dynamic-ng-bootstrap-rating",
                template: "<ng-container [formGroup]=\"group\">\r\n\r\n    <ngb-rating [formControlName]=\"model.id\"\r\n                [id]=\"elementId\"\r\n                [max]=\"model.max\"\r\n                [ngClass]=\"getClass('element', 'control')\"\r\n                [resettable]=\"model.getAdditional('resettable', config['resettable'])\"\r\n                (rateChange)=\"onChange($event)\"></ngb-rating>\r\n\r\n</ng-container>\r\n",
                changeDetection: ChangeDetectionStrategy.OnPush
            }] }
];
/** @nocollapse */
DynamicNGBootstrapRatingComponent.ctorParameters = () => [
    { type: DynamicFormLayoutService },
    { type: DynamicFormValidationService },
    { type: NgbRatingConfig }
];
DynamicNGBootstrapRatingComponent.propDecorators = {
    group: [{ type: Input }],
    layout: [{ type: Input }],
    model: [{ type: Input }],
    blur: [{ type: Output }],
    change: [{ type: Output }],
    focus: [{ type: Output }],
    ngbRating: [{ type: ViewChild, args: [NgbRating,] }]
};
if (false) {
    /** @type {?} */
    DynamicNGBootstrapRatingComponent.prototype.group;
    /** @type {?} */
    DynamicNGBootstrapRatingComponent.prototype.layout;
    /** @type {?} */
    DynamicNGBootstrapRatingComponent.prototype.model;
    /** @type {?} */
    DynamicNGBootstrapRatingComponent.prototype.blur;
    /** @type {?} */
    DynamicNGBootstrapRatingComponent.prototype.change;
    /** @type {?} */
    DynamicNGBootstrapRatingComponent.prototype.focus;
    /** @type {?} */
    DynamicNGBootstrapRatingComponent.prototype.ngbRating;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGBootstrapRatingComponent.prototype.layoutService;
    /**
     * @type {?}
     * @protected
     */
    DynamicNGBootstrapRatingComponent.prototype.validationService;
    /** @type {?} */
    DynamicNGBootstrapRatingComponent.prototype.config;
}
//# sourceMappingURL=dynamic-ng-bootstrap-rating.component.js.map